//----------------------------------------------------------------------------
//
//RMIChatClient.java, a text chat client program of a server/client pair,
//using RMI callback function.
//
//----------------------------------------------------------------------------

import java.awt.*;
import java.rmi.*;
import java.io.*;
import java.applet.Applet;
import java.awt.event.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.Vector;
import java.util.Enumeration;

//Chat client applet

public class RMIChatClient extends Applet implements RMIChatNotify, ActionListener ,ItemListener   {

    public RMIChatIF server_obj;    //RMI server interface object
    public Font bolditalicFont;
    boolean is_connected = false;  //whether the user has logged in the server
    String userName;    //a unique chat user name

    TextField textField;  //get user input message
    TextArea textArea;  //display chat message
    TextArea userList;   //display user list

    Button reloginButton;
    Button clearButton;
    Button logoutButton;



    Label label1, label2, label3 , labelmsg, wel ;

	Choice num1  ;    // To identify chat room selected by the user

	TextField name, lastname ,msg ,hastir, wel1;       // First menu elements , they kept user name and last name

	Button next , sendbutton ;

	TextArea   messagearea ;                       // Computer Messages are shown here

	Panel p1 , p2 ,p3 ,controlPanel,wl1Panel,mainPanel ;     // Menu panels


	CardLayout cl;                        // Menu Manager


	  // Following variables are used for calculations and arguments

	String sname , slastname ;            // User  name and Last Name

	int room ;

	Font f = new Font ("Serif", Font.BOLD, 25);
	Font f2 = new Font ("Dialog", Font.BOLD, 17);
	Font f3 = new Font ("Dialog", Font.BOLD, 12);

   //implement initialization work

    public void init() {

        try {
            // export the applet as a remote object
            System.out.println("RMIChatApplet.init: exporting remote object");
            UnicastRemoteObject.exportObject(this);

            // lookup  chat server
            String url = getParameter("url");
            server_obj = (RMIChatIF) Naming.lookup(url);
        } catch (Exception e) {
            // fatal error
            System.out.println("got exception: " + e.getMessage());
            e.printStackTrace();
            return;
        }



       p1 = new Panel();                     // First Menu
  	   p2 = new Panel();                     // Second Menu
  	   p3 = new Panel();                     // Third Menu



      //MAIN MENU ARRANGEMENTS

  cl = new CardLayout();
  p3.setLayout(cl);

  GridBagConstraints gbc = new GridBagConstraints();
  GridBagLayout gbl=new GridBagLayout();


  // FIRST MENU ARRANGEMENTS

  p1.setLayout(gbl);

  setLayout(gbl);

  setFont (f);
  Panel WellcomePanel = new Panel();
  Panel NamePanel = new Panel();
  Panel LastnPanel = new Panel();
  Panel ThirdRow = new Panel();

  next = new Button ( " Enter  ");
  next.addActionListener(this);

  NamePanel.setLayout(new GridLayout(3,2));

  LastnPanel.setLayout(new GridLayout(3,2));

  WellcomePanel.setLayout(new GridLayout(3,2));


  hastir = new TextField( "WELCOME TO THE WEB CHAT" ,30 );
  bolditalicFont  = ( new Font (" Serif", Font.PLAIN+ Font.BOLD, 38) );
  hastir.setFont( bolditalicFont) ;
  hastir.setBackground(Color.white);
  hastir.addActionListener(this);


  WellcomePanel.add(hastir);

  label1 = new Label( "Name:", Label.LEFT );
  name = new TextField( 20 );
  name.addActionListener(this);
  name.setBackground(Color.white);
  NamePanel.add(label1);
  NamePanel.add(name);


  label2 = new Label("Surname:", Label.LEFT );
  lastname = new TextField( 20 );
  lastname.addActionListener(this);
  lastname.setBackground(Color.white);

  LastnPanel.add(label2);
  LastnPanel.add(lastname);

  label3 = new Label("Select your chat room:", Label.LEFT );

   // room selection
    num1 = new Choice() ;
    num1.addItem ("Blue   (0) ");
    num1.addItem ("Green  (1) ");
    num1.addItem ("Red    (2) ");
    num1.addItem ("Yellow (3) ");

    num1.addItemListener(this);



  gbc.gridx = 1;
  gbc.gridy = 1;
  gbl.setConstraints(WellcomePanel, gbc);
  p1.add(WellcomePanel);




  gbc.gridx = 1;
  gbc.gridy = 3;
  gbl.setConstraints(NamePanel, gbc);
  p1.add(NamePanel);

  gbc.gridx = 1;
  gbc.gridy = 5;
  gbl.setConstraints(LastnPanel, gbc);
  p1.add(LastnPanel);



 ThirdRow.setLayout(new GridLayout(2,2));

  ThirdRow.add(label3);
  ThirdRow.add(num1);

  gbc.gridx = 1;
  gbc.gridy = 7;
  p1.add(ThirdRow,gbc);

  gbc.gridx = 1;
  gbc.gridy = 9;
  p1.add(next,gbc);

  p1.setBackground(Color.magenta);


//Second Menu Arrangements

 // Define text field sizes
        textField = new TextField(50);
        textField.addActionListener( this );
        textArea = new TextArea(12, 100);
        textArea.setEditable(false);
        userList = new TextArea(12,10);
        userList.setEditable(false);

        // Define buttons for chat
       reloginButton = new Button ("RELOGIN");  //the login button
       reloginButton.addActionListener( this );
        clearButton = new Button("DELETE ALL MESSAGES");
        clearButton.addActionListener( this );
        logoutButton = new Button("DISCONNECT");  //The logout button
        logoutButton.addActionListener( this );

        Panel controlPanel = new Panel();
        controlPanel.add(reloginButton);
        controlPanel.add(clearButton);
        controlPanel.add(logoutButton);

        //Overall layout
        setFont(new Font("Helvetica", Font.PLAIN, 12));
        Panel mainPanel = new Panel();
        mainPanel.setLayout(new BorderLayout());
        mainPanel.add("Center", textArea);
        mainPanel.add("West", userList);
        Panel inputPanel = new Panel();
        inputPanel.setLayout( new BorderLayout() );
        inputPanel.add("West", new Label("YOUR MSG >>"));
        inputPanel.add("Center", textField);
        mainPanel.add("South",  inputPanel);

        setLayout(new BorderLayout());
        p2.add("Center", mainPanel);
        p2.add("South", controlPanel);


        p3.add("card1",p1);



		setLayout(new BorderLayout());

        add("Center",p3);

        display("Please type a string as your  message in the chat text field,");
        display("Then press ENTER key ");
    }

    //login the client to chat server, register client as a call back object


    void relogin(String msg ) {
        if(msg.length()==0) return;

        display("Preparing to login.");
        try {
            if( server_obj.login(msg,room,this) ) {    //if succeeded
                is_connected=true;
                userName=msg;
                display("You have logged in as "+userName);
            }
            else {
                display("Login failed. Please select another ID and try again...");
            }
        } catch(Exception ex) {
            System.out.println("RMIClient: Exception-> " + ex) ;
            ex.printStackTrace();
        }
        textField.setText("");    //clear input text field
    }



    //display a line of text in main text area

    void display(String s){
        textArea.append(s+'\n');
    }

    //process user commands

        public void itemStateChanged(ItemEvent evt)
	    {
	       if (evt.getSource()==num1) room = num1.getSelectedIndex();
	    }


    public void actionPerformed(ActionEvent evt) {
        Object source = evt.getSource();
        String msg = textField.getText().trim();

        if(source==next)
		 		 {

				  is_connected=true;
		 		  sname ="";
		 		  slastname = "";
		 		  sname = name.getText();
		 		  slastname = lastname.getText();
		 		  int k = sname.length()+slastname.length();
			       if(k!=0)
		 	        {
		            name.setText("");
		            lastname.setText("");

		 	        } // end of if


		 	        msg=sname+" "+slastname;

		 	        if(msg.length()==0) return;

			        display("Preparing to login.");
			        try {
		            		if( server_obj.login(msg,room,this) )
		            		{    //if succeeded
				                is_connected=true;
				                userName=msg;
				                display("You have logged in as "+userName);
				    		 }
		            		else
		            		{
			        		  display("Login failed. Please select another ID and try again...");
							}
					    }

					 catch(Exception ex)
					 		{
					           System.out.println("RMIClient: Exception-> " + ex) ;
					            ex.printStackTrace();
					        }



        textField.setText("");    //clear input text field


  switch(room)
   {
	   case 0 :
	   {


        p2.setBackground(Color.blue);

        break;
       }

       case 1 :
	   	   {
	        p2.setBackground(Color.green);
	           break;
	       }

	   case 2 :
	   {
        p2.setBackground(Color.red);
        break;
       }

       case 3 :
	   {
	    p2.setBackground(Color.yellow);
	    break;
	   }



} //end of switch


         p3.add("card2",p2);
	     cl.show(p3, "card2");



	     } // end of if






        //RELOGIN
       if( (! is_connected )&&(source==reloginButton))
       {
                userList.setText("");
                relogin(msg);
            return;
        }

        //process chat command when connected

        if (source == logoutButton ) {  //logout the client, prepare for next login
            try {
                server_obj.logout(userName,room, this);
                is_connected=false;
                userName="";
                textArea.setText("");
                userList.setText("");
                display("Preparing to log off.");  //log out first
                display("Please type a string as your  ID in the chat text field,");
                display("Then press ENTER key or the login button...");
            } catch(Exception ex) {
                System.out.println("RMIClient: Exception-> " + ex) ;
                ex.printStackTrace();
            }
        }
        else if (source == clearButton){ //user wants to clear text
            textArea.setText("");
        }
        else if (source == textField && msg.length()>0){
            //user wants to send chat message
            try {

				server_obj.sendMsg( userName, textField.getText() , room );
            } catch(Exception ex) {
                System.out.println("RMIClient: Exception-> " + ex) ;
                ex.printStackTrace();
            }
            textField.setText("");
        }

    }

    //--------------------------------------------------------------------------------------
    //The next two functions implement the RMIChatNotify callback interface

    public void receiveMsg(String userID, String s , int srn ) throws java.rmi.RemoteException
    {
      if(srn==room   )

        display(userID + ": " + s );
    }

    public void receiveUserList(Vector ul ) throws java.rmi.RemoteException {
        userList.setText("User ID:\n");
        Enumeration enum = ul.elements();
        while (enum.hasMoreElements()) {

			 String Temp = (String)enum.nextElement();
			 String rn= Temp.substring(0, 1);
			 int u1 =Integer.parseInt(rn);
			 int l = Temp.length();

            if (u1==room)userList.append(Temp.substring(1, l) +'\n' ); //write this user list
        }
    }

}

